

local DescriptCfg = require("src/app/cfg/DescriptCfg")
GmActivity = class("GmActivity",function()
    return display.newLayer()
end)




--限时折扣礼包


local myActivityId = 151


function GmActivity:ctor()

    self.Top = CCUILoader:load("res/csd/public/PanelBgLarge.csb")
    self:addChild(self.Top)

    

    --关闭
    local close = self.Top:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            self:getParent():getActivityList()
            self:removeFromParent()
        end
    end)

    --新服关卡信息
    self.Top_Chanllenge = CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/limited_time_discount_activity/ui_limited_time_discount_activity_main.csb")
    self:addChild(self.Top_Chanllenge)

    --self:fresh()
end

function GmActivity:setActivityId(id)
	myActivityId = id
    self.Top:getChildByName("text_title"):setString(gActivity[myActivityId].name)
    local msg = {type = myActivityId}
    Connect:sendMsg("ActivityGmAction","openActivityGm",msg,
        function(data)
            local pd = PlayerData:getInstanse()
            --更新数据
            self.data = data
            self:freshInfo()
        end)
end

function GmActivity:freshInfo()

    local pd = PlayerData:getInstanse()
    --时间
    self.Top_Chanllenge:getChildByName("panel_main_bg"):getChildByName("text_title"):setString(self.data.desc)
    self.Top_Chanllenge:getChildByName("panel_main_bg"):getChildByName("text_time"):setString(self.data.desc2)
    --list
    local panelList = self.Top_Chanllenge:getChildByName("panel_main_bg"):getChildByName("panel_item_bg"):getChildByName("listview_item")
    panelList:removeAllItems()
    
    table.sort(self.data.rewards,function(a,b)
        return a.reward_id < b.reward_id
    end)
    
    --道具列表
    for key, var in pairs(self.data.rewards) do
    
        local item = self.Top_Chanllenge:getChildByName("panel_main_bg"):getChildByName("panel_item_bg"):getChildByName("panel_item"):clone()
        panelList:pushBackCustomItem(item)
        local goodsInfo=StringUtil.getGoodsInfo(var.goodsId,var.goodsType)
        --名称

        item:getChildByName("panel_bg"):getChildByName("text_name"):setString(var.desc)
        -- 各种类型的奖励，需要区分图标
        Common:changePic(item:getChildByName("panel_bg"):getChildByName("icon_item"),goodsInfo.icon)
        --原价
        item:getChildByName("panel_bg"):getChildByName("text_num_02"):setVisible(false)
        --优惠
        item:getChildByName("panel_bg"):getChildByName("text_discount"):setVisible(false)
        --金币图标
        item:getChildByName("panel_bg"):getChildByName("icon_coin_02"):setVisible(false)
        --删除线
        item:getChildByName("panel_bg"):getChildByName("icon_line"):setVisible(false)
        --折扣比例
        item:getChildByName("panel_bg"):getChildByName("text_num"):setVisible(false)
        --次数
        item:getChildByName("panel_bg"):getChildByName("text_desc"):setVisible(false)
        
        --折扣价格
        item:getChildByName("panel_bg"):getChildByName("text_num_01"):setString(var.gold)
        

        
        --购买按钮
        local btn = item:getChildByName("panel_bg"):getChildByName("btn_buy")
        btn:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                if var.status==0 then
                    PromptView:type2(StringRes.notice,
                            string.format(StringRes.text_gm_shop_pay,self.data.price)
                    ,StringRes.ok,StringRes.cancel,
                            function()
                                --到支付界面
                                Recharge:show(gWorldScene)
                            end)
                elseif var.status==2 then
                    PromptView:type1(StringRes.notice,StringRes.text_gm_shop_repet,StringRes.ok)
                elseif pd.basicData.gold < var.gold then
                --gold_not_enough
                    PromptView:type2(StringRes.notice,
                        string.format(StringRes.gold_not_enough,var.discountPrice,pd.basicData.gold,var.gold-pd.basicData.gold )
                        ,StringRes.ok,StringRes.cancel,
                        function()
                            --到支付界面
                            Recharge:show(gWorldScene)
                        end)
                else
                    local msg = {type = myActivityId,reward_id = var.reward_id}
                    Connect:sendMsg("ActivityGmAction","buyActivityGm",msg,
                        function(data)
                            local pd = PlayerData:getInstanse()
                            --更新玩家金币
                            pd.basicData.gold = data.gold
                            pd.basicData = data.info
                            pd.tanks = data.troops
                            --刷新数据
                            self:setActivityId(myActivityId)
                            local str = var.desc
                            FlyWordPrompt:prompt(str)
                        end)
                end
            end
        end)
        
        
    end
    
    
    
    
end

return GmActivity